// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from rc_reason_msgs:srv/CadMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__BUILDER_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "rc_reason_msgs/srv/detail/cad_match_detect_object__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_CadMatchDetectObject_Request_collision_detection
{
public:
  explicit Init_CadMatchDetectObject_Request_collision_detection(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request collision_detection(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_collision_detection_type arg)
  {
    msg_.collision_detection = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_robot_pose
{
public:
  explicit Init_CadMatchDetectObject_Request_robot_pose(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Request_collision_detection robot_pose(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_robot_pose_type arg)
  {
    msg_.robot_pose = std::move(arg);
    return Init_CadMatchDetectObject_Request_collision_detection(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_load_carrier_compartment
{
public:
  explicit Init_CadMatchDetectObject_Request_load_carrier_compartment(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Request_robot_pose load_carrier_compartment(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_load_carrier_compartment_type arg)
  {
    msg_.load_carrier_compartment = std::move(arg);
    return Init_CadMatchDetectObject_Request_robot_pose(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_load_carrier_id
{
public:
  explicit Init_CadMatchDetectObject_Request_load_carrier_id(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Request_load_carrier_compartment load_carrier_id(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_load_carrier_id_type arg)
  {
    msg_.load_carrier_id = std::move(arg);
    return Init_CadMatchDetectObject_Request_load_carrier_compartment(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_region_of_interest_id
{
public:
  explicit Init_CadMatchDetectObject_Request_region_of_interest_id(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Request_load_carrier_id region_of_interest_id(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_region_of_interest_id_type arg)
  {
    msg_.region_of_interest_id = std::move(arg);
    return Init_CadMatchDetectObject_Request_load_carrier_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_pose_frame
{
public:
  explicit Init_CadMatchDetectObject_Request_pose_frame(::rc_reason_msgs::srv::CadMatchDetectObject_Request & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Request_region_of_interest_id pose_frame(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_pose_frame_type arg)
  {
    msg_.pose_frame = std::move(arg);
    return Init_CadMatchDetectObject_Request_region_of_interest_id(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

class Init_CadMatchDetectObject_Request_template_id
{
public:
  Init_CadMatchDetectObject_Request_template_id()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_CadMatchDetectObject_Request_pose_frame template_id(::rc_reason_msgs::srv::CadMatchDetectObject_Request::_template_id_type arg)
  {
    msg_.template_id = std::move(arg);
    return Init_CadMatchDetectObject_Request_pose_frame(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Request msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::CadMatchDetectObject_Request>()
{
  return rc_reason_msgs::srv::builder::Init_CadMatchDetectObject_Request_template_id();
}

}  // namespace rc_reason_msgs


namespace rc_reason_msgs
{

namespace srv
{

namespace builder
{

class Init_CadMatchDetectObject_Response_return_code
{
public:
  explicit Init_CadMatchDetectObject_Response_return_code(::rc_reason_msgs::srv::CadMatchDetectObject_Response & msg)
  : msg_(msg)
  {}
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response return_code(::rc_reason_msgs::srv::CadMatchDetectObject_Response::_return_code_type arg)
  {
    msg_.return_code = std::move(arg);
    return std::move(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response msg_;
};

class Init_CadMatchDetectObject_Response_load_carriers
{
public:
  explicit Init_CadMatchDetectObject_Response_load_carriers(::rc_reason_msgs::srv::CadMatchDetectObject_Response & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Response_return_code load_carriers(::rc_reason_msgs::srv::CadMatchDetectObject_Response::_load_carriers_type arg)
  {
    msg_.load_carriers = std::move(arg);
    return Init_CadMatchDetectObject_Response_return_code(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response msg_;
};

class Init_CadMatchDetectObject_Response_grasps
{
public:
  explicit Init_CadMatchDetectObject_Response_grasps(::rc_reason_msgs::srv::CadMatchDetectObject_Response & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Response_load_carriers grasps(::rc_reason_msgs::srv::CadMatchDetectObject_Response::_grasps_type arg)
  {
    msg_.grasps = std::move(arg);
    return Init_CadMatchDetectObject_Response_load_carriers(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response msg_;
};

class Init_CadMatchDetectObject_Response_matches
{
public:
  explicit Init_CadMatchDetectObject_Response_matches(::rc_reason_msgs::srv::CadMatchDetectObject_Response & msg)
  : msg_(msg)
  {}
  Init_CadMatchDetectObject_Response_grasps matches(::rc_reason_msgs::srv::CadMatchDetectObject_Response::_matches_type arg)
  {
    msg_.matches = std::move(arg);
    return Init_CadMatchDetectObject_Response_grasps(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response msg_;
};

class Init_CadMatchDetectObject_Response_timestamp
{
public:
  Init_CadMatchDetectObject_Response_timestamp()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_CadMatchDetectObject_Response_matches timestamp(::rc_reason_msgs::srv::CadMatchDetectObject_Response::_timestamp_type arg)
  {
    msg_.timestamp = std::move(arg);
    return Init_CadMatchDetectObject_Response_matches(msg_);
  }

private:
  ::rc_reason_msgs::srv::CadMatchDetectObject_Response msg_;
};

}  // namespace builder

}  // namespace srv

template<typename MessageType>
auto build();

template<>
inline
auto build<::rc_reason_msgs::srv::CadMatchDetectObject_Response>()
{
  return rc_reason_msgs::srv::builder::Init_CadMatchDetectObject_Response_timestamp();
}

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__BUILDER_HPP_
