// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/CalibrateBasePlane.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose_frame'
// Member 'plane_estimation_method'
// Member 'stereo_plane_preference'
// Member 'region_of_interest_2d_id'
#include "rosidl_runtime_c/string.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'plane'
#include "shape_msgs/msg/detail/plane__struct.h"

/// Struct defined in srv/CalibrateBasePlane in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__CalibrateBasePlane_Request
{
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
  /// Required. Method to use for base-plane estimation
  /// Valid values are:
  /// STEREO
  /// APRILTAG
  /// MANUAL
  rosidl_runtime_c__String plane_estimation_method;
  /// Options for STEREO calibration
  rosidl_runtime_c__String stereo_plane_preference;
  /// Optional
  rosidl_runtime_c__String region_of_interest_2d_id;
  /// Optional. Shift in meters that will be applied to the estimated plane
  double offset;
  /// Reqired only if plane_estimation_method = MANUAL
  shape_msgs__msg__Plane plane;
} rc_reason_msgs__srv__CalibrateBasePlane_Request;

// Struct for a sequence of rc_reason_msgs__srv__CalibrateBasePlane_Request.
typedef struct rc_reason_msgs__srv__CalibrateBasePlane_Request__Sequence
{
  rc_reason_msgs__srv__CalibrateBasePlane_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__CalibrateBasePlane_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'pose_frame'
// already included above
// #include "rosidl_runtime_c/string.h"
// Member 'plane'
// already included above
// #include "shape_msgs/msg/detail/plane__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/CalibrateBasePlane in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__CalibrateBasePlane_Response
{
  /// timestamp of the image set the calibration ran on
  builtin_interfaces__msg__Time timestamp;
  /// frame in which plane is given
  rosidl_runtime_c__String pose_frame;
  shape_msgs__msg__Plane plane;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__CalibrateBasePlane_Response;

// Struct for a sequence of rc_reason_msgs__srv__CalibrateBasePlane_Response.
typedef struct rc_reason_msgs__srv__CalibrateBasePlane_Response__Sequence
{
  rc_reason_msgs__srv__CalibrateBasePlane_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__CalibrateBasePlane_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__CALIBRATE_BASE_PLANE__STRUCT_H_
