// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from rc_reason_msgs:srv/GetLoadCarriers.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__STRUCT_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Request __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Request __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetLoadCarriers_Request_
{
  using Type = GetLoadCarriers_Request_<ContainerAllocator>;

  explicit GetLoadCarriers_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
  }

  explicit GetLoadCarriers_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_init;
    (void)_alloc;
  }

  // field types and members
  using _load_carrier_ids_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _load_carrier_ids_type load_carrier_ids;

  // setters for named parameter idiom
  Type & set__load_carrier_ids(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->load_carrier_ids = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Request
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Request
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetLoadCarriers_Request_ & other) const
  {
    if (this->load_carrier_ids != other.load_carrier_ids) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetLoadCarriers_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetLoadCarriers_Request_

// alias to use template instance with default allocator
using GetLoadCarriers_Request =
  rc_reason_msgs::srv::GetLoadCarriers_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs


// Include directives for member types
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier_model__struct.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Response __attribute__((deprecated))
#else
# define DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Response __declspec(deprecated)
#endif

namespace rc_reason_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct GetLoadCarriers_Response_
{
  using Type = GetLoadCarriers_Response_<ContainerAllocator>;

  explicit GetLoadCarriers_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : return_code(_init)
  {
    (void)_init;
  }

  explicit GetLoadCarriers_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : return_code(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _load_carriers_type =
    std::vector<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>>;
  _load_carriers_type load_carriers;
  using _return_code_type =
    rc_common_msgs::msg::ReturnCode_<ContainerAllocator>;
  _return_code_type return_code;

  // setters for named parameter idiom
  Type & set__load_carriers(
    const std::vector<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<rc_reason_msgs::msg::LoadCarrierModel_<ContainerAllocator>>> & _arg)
  {
    this->load_carriers = _arg;
    return *this;
  }
  Type & set__return_code(
    const rc_common_msgs::msg::ReturnCode_<ContainerAllocator> & _arg)
  {
    this->return_code = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Response
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__rc_reason_msgs__srv__GetLoadCarriers_Response
    std::shared_ptr<rc_reason_msgs::srv::GetLoadCarriers_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const GetLoadCarriers_Response_ & other) const
  {
    if (this->load_carriers != other.load_carriers) {
      return false;
    }
    if (this->return_code != other.return_code) {
      return false;
    }
    return true;
  }
  bool operator!=(const GetLoadCarriers_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct GetLoadCarriers_Response_

// alias to use template instance with default allocator
using GetLoadCarriers_Response =
  rc_reason_msgs::srv::GetLoadCarriers_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rc_reason_msgs
{

namespace srv
{

struct GetLoadCarriers
{
  using Request = rc_reason_msgs::srv::GetLoadCarriers_Request;
  using Response = rc_reason_msgs::srv::GetLoadCarriers_Response;
};

}  // namespace srv

}  // namespace rc_reason_msgs

#endif  // RC_REASON_MSGS__SRV__DETAIL__GET_LOAD_CARRIERS__STRUCT_HPP_
