// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/SetHandEyeCalibration.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.h"

/// Struct defined in srv/SetHandEyeCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibration_Request
{
  /// Relative pose of grid with respect to the frame for which the pose was given in the request of SetCalibrationPose
  geometry_msgs__msg__Pose pose;
  /// True if calibration was done with sensor mounted on robot
  bool robot_mounted;
} rc_reason_msgs__srv__SetHandEyeCalibration_Request;

// Struct for a sequence of rc_reason_msgs__srv__SetHandEyeCalibration_Request.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence
{
  rc_reason_msgs__srv__SetHandEyeCalibration_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SetHandEyeCalibration_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'message'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SetHandEyeCalibration in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibration_Response
{
  bool success;
  /// Internal status:
  /// 0: Success
  /// 7: License not available
  /// 12: Invalid orientation given, i.e. quaternion must have length 1
  int32_t status;
  /// Human readable message, for development
  rosidl_runtime_c__String message;
} rc_reason_msgs__srv__SetHandEyeCalibration_Response;

// Struct for a sequence of rc_reason_msgs__srv__SetHandEyeCalibration_Response.
typedef struct rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence
{
  rc_reason_msgs__srv__SetHandEyeCalibration_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__SetHandEyeCalibration_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__SET_HAND_EYE_CALIBRATION__STRUCT_H_
