// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:srv/SilhouetteMatchDetectObject.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/srv/detail/silhouette_match_detect_object__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"

// Include directives for member types
// Member `object_to_detect`
#include "rc_reason_msgs/msg/detail/silhouette_match_object__functions.h"
// Member `pose_frame`
// Member `load_carrier_id`
#include "rosidl_runtime_c/string_functions.h"
// Member `robot_pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `collision_detection`
#include "rc_reason_msgs/msg/detail/collision_detection__functions.h"

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__init(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * msg)
{
  if (!msg) {
    return false;
  }
  // object_to_detect
  if (!rc_reason_msgs__msg__SilhouetteMatchObject__init(&msg->object_to_detect)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
    return false;
  }
  // offset
  // pose_frame
  if (!rosidl_runtime_c__String__init(&msg->pose_frame)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
    return false;
  }
  // robot_pose
  if (!geometry_msgs__msg__Pose__init(&msg->robot_pose)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
    return false;
  }
  // load_carrier_id
  if (!rosidl_runtime_c__String__init(&msg->load_carrier_id)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
    return false;
  }
  // collision_detection
  if (!rc_reason_msgs__msg__CollisionDetection__init(&msg->collision_detection)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * msg)
{
  if (!msg) {
    return;
  }
  // object_to_detect
  rc_reason_msgs__msg__SilhouetteMatchObject__fini(&msg->object_to_detect);
  // offset
  // pose_frame
  rosidl_runtime_c__String__fini(&msg->pose_frame);
  // robot_pose
  geometry_msgs__msg__Pose__fini(&msg->robot_pose);
  // load_carrier_id
  rosidl_runtime_c__String__fini(&msg->load_carrier_id);
  // collision_detection
  rc_reason_msgs__msg__CollisionDetection__fini(&msg->collision_detection);
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__are_equal(const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * lhs, const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // object_to_detect
  if (!rc_reason_msgs__msg__SilhouetteMatchObject__are_equal(
      &(lhs->object_to_detect), &(rhs->object_to_detect)))
  {
    return false;
  }
  // offset
  if (lhs->offset != rhs->offset) {
    return false;
  }
  // pose_frame
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->pose_frame), &(rhs->pose_frame)))
  {
    return false;
  }
  // robot_pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->robot_pose), &(rhs->robot_pose)))
  {
    return false;
  }
  // load_carrier_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->load_carrier_id), &(rhs->load_carrier_id)))
  {
    return false;
  }
  // collision_detection
  if (!rc_reason_msgs__msg__CollisionDetection__are_equal(
      &(lhs->collision_detection), &(rhs->collision_detection)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__copy(
  const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * input,
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * output)
{
  if (!input || !output) {
    return false;
  }
  // object_to_detect
  if (!rc_reason_msgs__msg__SilhouetteMatchObject__copy(
      &(input->object_to_detect), &(output->object_to_detect)))
  {
    return false;
  }
  // offset
  output->offset = input->offset;
  // pose_frame
  if (!rosidl_runtime_c__String__copy(
      &(input->pose_frame), &(output->pose_frame)))
  {
    return false;
  }
  // robot_pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->robot_pose), &(output->robot_pose)))
  {
    return false;
  }
  // load_carrier_id
  if (!rosidl_runtime_c__String__copy(
      &(input->load_carrier_id), &(output->load_carrier_id)))
  {
    return false;
  }
  // collision_detection
  if (!rc_reason_msgs__msg__CollisionDetection__copy(
      &(input->collision_detection), &(output->collision_detection)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request *
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * msg = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request *)allocator.allocate(sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request));
  bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__destroy(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__init(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__fini(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence *
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * array = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__destroy(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__are_equal(const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * lhs, const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence__copy(
  const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * input,
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request * data =
      (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Request__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}


// Include directives for member types
// Member `timestamp`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `matches`
#include "rc_reason_msgs/msg/detail/match__functions.h"
// Member `grasps`
#include "rc_reason_msgs/msg/detail/grasp__functions.h"
// Member `load_carriers`
#include "rc_reason_msgs/msg/detail/load_carrier__functions.h"
// Member `return_code`
#include "rc_common_msgs/msg/detail/return_code__functions.h"

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__init(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * msg)
{
  if (!msg) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__init(&msg->timestamp)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
    return false;
  }
  // matches
  if (!rc_reason_msgs__msg__Match__Sequence__init(&msg->matches, 0)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
    return false;
  }
  // grasps
  if (!rc_reason_msgs__msg__Grasp__Sequence__init(&msg->grasps, 0)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
    return false;
  }
  // load_carriers
  if (!rc_reason_msgs__msg__LoadCarrier__Sequence__init(&msg->load_carriers, 0)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__init(&msg->return_code)) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
    return false;
  }
  return true;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * msg)
{
  if (!msg) {
    return;
  }
  // timestamp
  builtin_interfaces__msg__Time__fini(&msg->timestamp);
  // matches
  rc_reason_msgs__msg__Match__Sequence__fini(&msg->matches);
  // grasps
  rc_reason_msgs__msg__Grasp__Sequence__fini(&msg->grasps);
  // load_carriers
  rc_reason_msgs__msg__LoadCarrier__Sequence__fini(&msg->load_carriers);
  // return_code
  rc_common_msgs__msg__ReturnCode__fini(&msg->return_code);
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__are_equal(const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * lhs, const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__are_equal(
      &(lhs->timestamp), &(rhs->timestamp)))
  {
    return false;
  }
  // matches
  if (!rc_reason_msgs__msg__Match__Sequence__are_equal(
      &(lhs->matches), &(rhs->matches)))
  {
    return false;
  }
  // grasps
  if (!rc_reason_msgs__msg__Grasp__Sequence__are_equal(
      &(lhs->grasps), &(rhs->grasps)))
  {
    return false;
  }
  // load_carriers
  if (!rc_reason_msgs__msg__LoadCarrier__Sequence__are_equal(
      &(lhs->load_carriers), &(rhs->load_carriers)))
  {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__are_equal(
      &(lhs->return_code), &(rhs->return_code)))
  {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__copy(
  const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * input,
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * output)
{
  if (!input || !output) {
    return false;
  }
  // timestamp
  if (!builtin_interfaces__msg__Time__copy(
      &(input->timestamp), &(output->timestamp)))
  {
    return false;
  }
  // matches
  if (!rc_reason_msgs__msg__Match__Sequence__copy(
      &(input->matches), &(output->matches)))
  {
    return false;
  }
  // grasps
  if (!rc_reason_msgs__msg__Grasp__Sequence__copy(
      &(input->grasps), &(output->grasps)))
  {
    return false;
  }
  // load_carriers
  if (!rc_reason_msgs__msg__LoadCarrier__Sequence__copy(
      &(input->load_carriers), &(output->load_carriers)))
  {
    return false;
  }
  // return_code
  if (!rc_common_msgs__msg__ReturnCode__copy(
      &(input->return_code), &(output->return_code)))
  {
    return false;
  }
  return true;
}

rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response *
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * msg = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response *)allocator.allocate(sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response));
  bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__destroy(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__init(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * data = NULL;

  if (size) {
    data = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__fini(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence *
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * array = (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__destroy(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__are_equal(const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * lhs, const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence__copy(
  const rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * input,
  rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response * data =
      (rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__srv__SilhouetteMatchDetectObject_Response__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
