// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from rc_reason_msgs:msg/Match.idl
// generated code does not contain a copyright notice
#include "rc_reason_msgs/msg/detail/match__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `template_id`
// Member `uuid`
// Member `grasp_uuids`
#include "rosidl_runtime_c/string_functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose_stamped__functions.h"

bool
rc_reason_msgs__msg__Match__init(rc_reason_msgs__msg__Match * msg)
{
  if (!msg) {
    return false;
  }
  // template_id
  if (!rosidl_runtime_c__String__init(&msg->template_id)) {
    rc_reason_msgs__msg__Match__fini(msg);
    return false;
  }
  // uuid
  if (!rosidl_runtime_c__String__init(&msg->uuid)) {
    rc_reason_msgs__msg__Match__fini(msg);
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__init(&msg->pose)) {
    rc_reason_msgs__msg__Match__fini(msg);
    return false;
  }
  // grasp_uuids
  if (!rosidl_runtime_c__String__Sequence__init(&msg->grasp_uuids, 0)) {
    rc_reason_msgs__msg__Match__fini(msg);
    return false;
  }
  // score
  return true;
}

void
rc_reason_msgs__msg__Match__fini(rc_reason_msgs__msg__Match * msg)
{
  if (!msg) {
    return;
  }
  // template_id
  rosidl_runtime_c__String__fini(&msg->template_id);
  // uuid
  rosidl_runtime_c__String__fini(&msg->uuid);
  // pose
  geometry_msgs__msg__PoseStamped__fini(&msg->pose);
  // grasp_uuids
  rosidl_runtime_c__String__Sequence__fini(&msg->grasp_uuids);
  // score
}

bool
rc_reason_msgs__msg__Match__are_equal(const rc_reason_msgs__msg__Match * lhs, const rc_reason_msgs__msg__Match * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // template_id
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->template_id), &(rhs->template_id)))
  {
    return false;
  }
  // uuid
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->uuid), &(rhs->uuid)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // grasp_uuids
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->grasp_uuids), &(rhs->grasp_uuids)))
  {
    return false;
  }
  // score
  if (lhs->score != rhs->score) {
    return false;
  }
  return true;
}

bool
rc_reason_msgs__msg__Match__copy(
  const rc_reason_msgs__msg__Match * input,
  rc_reason_msgs__msg__Match * output)
{
  if (!input || !output) {
    return false;
  }
  // template_id
  if (!rosidl_runtime_c__String__copy(
      &(input->template_id), &(output->template_id)))
  {
    return false;
  }
  // uuid
  if (!rosidl_runtime_c__String__copy(
      &(input->uuid), &(output->uuid)))
  {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__PoseStamped__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // grasp_uuids
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->grasp_uuids), &(output->grasp_uuids)))
  {
    return false;
  }
  // score
  output->score = input->score;
  return true;
}

rc_reason_msgs__msg__Match *
rc_reason_msgs__msg__Match__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Match * msg = (rc_reason_msgs__msg__Match *)allocator.allocate(sizeof(rc_reason_msgs__msg__Match), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(rc_reason_msgs__msg__Match));
  bool success = rc_reason_msgs__msg__Match__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
rc_reason_msgs__msg__Match__destroy(rc_reason_msgs__msg__Match * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    rc_reason_msgs__msg__Match__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
rc_reason_msgs__msg__Match__Sequence__init(rc_reason_msgs__msg__Match__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Match * data = NULL;

  if (size) {
    data = (rc_reason_msgs__msg__Match *)allocator.zero_allocate(size, sizeof(rc_reason_msgs__msg__Match), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = rc_reason_msgs__msg__Match__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        rc_reason_msgs__msg__Match__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
rc_reason_msgs__msg__Match__Sequence__fini(rc_reason_msgs__msg__Match__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      rc_reason_msgs__msg__Match__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

rc_reason_msgs__msg__Match__Sequence *
rc_reason_msgs__msg__Match__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  rc_reason_msgs__msg__Match__Sequence * array = (rc_reason_msgs__msg__Match__Sequence *)allocator.allocate(sizeof(rc_reason_msgs__msg__Match__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = rc_reason_msgs__msg__Match__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
rc_reason_msgs__msg__Match__Sequence__destroy(rc_reason_msgs__msg__Match__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    rc_reason_msgs__msg__Match__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
rc_reason_msgs__msg__Match__Sequence__are_equal(const rc_reason_msgs__msg__Match__Sequence * lhs, const rc_reason_msgs__msg__Match__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!rc_reason_msgs__msg__Match__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
rc_reason_msgs__msg__Match__Sequence__copy(
  const rc_reason_msgs__msg__Match__Sequence * input,
  rc_reason_msgs__msg__Match__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(rc_reason_msgs__msg__Match);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    rc_reason_msgs__msg__Match * data =
      (rc_reason_msgs__msg__Match *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!rc_reason_msgs__msg__Match__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          rc_reason_msgs__msg__Match__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!rc_reason_msgs__msg__Match__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
