// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from rc_reason_msgs:srv/CadMatchDetectObject.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__STRUCT_H_
#define RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'template_id'
// Member 'pose_frame'
// Member 'region_of_interest_id'
// Member 'load_carrier_id'
#include "rosidl_runtime_c/string.h"
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__struct.h"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__struct.h"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__struct.h"

/// Struct defined in srv/CadMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__CadMatchDetectObject_Request
{
  /// Required
  rosidl_runtime_c__String template_id;
  /// Required. Pose frame for output poses (valid values are camera and external)
  rosidl_runtime_c__String pose_frame;
  /// Optional
  rosidl_runtime_c__String region_of_interest_id;
  /// Optional
  rosidl_runtime_c__String load_carrier_id;
  /// Optional
  rc_reason_msgs__msg__Compartment load_carrier_compartment;
  /// Required only if reference frame = external and sensor is robot-mounted
  geometry_msgs__msg__Pose robot_pose;
  /// Optional. Enables collision checking of grasps with load carrier
  rc_reason_msgs__msg__CollisionDetection collision_detection;
} rc_reason_msgs__srv__CadMatchDetectObject_Request;

// Struct for a sequence of rc_reason_msgs__srv__CadMatchDetectObject_Request.
typedef struct rc_reason_msgs__srv__CadMatchDetectObject_Request__Sequence
{
  rc_reason_msgs__srv__CadMatchDetectObject_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__CadMatchDetectObject_Request__Sequence;


// Constants defined in the message

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__struct.h"
// Member 'matches'
#include "rc_reason_msgs/msg/detail/match__struct.h"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/grasp__struct.h"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__struct.h"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__struct.h"

/// Struct defined in srv/CadMatchDetectObject in the package rc_reason_msgs.
typedef struct rc_reason_msgs__srv__CadMatchDetectObject_Response
{
  builtin_interfaces__msg__Time timestamp;
  /// List of detected matches (instances) of the object
  rc_reason_msgs__msg__Match__Sequence matches;
  rc_reason_msgs__msg__Grasp__Sequence grasps;
  rc_reason_msgs__msg__LoadCarrier__Sequence load_carriers;
  rc_common_msgs__msg__ReturnCode return_code;
} rc_reason_msgs__srv__CadMatchDetectObject_Response;

// Struct for a sequence of rc_reason_msgs__srv__CadMatchDetectObject_Response.
typedef struct rc_reason_msgs__srv__CadMatchDetectObject_Response__Sequence
{
  rc_reason_msgs__srv__CadMatchDetectObject_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} rc_reason_msgs__srv__CadMatchDetectObject_Response__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // RC_REASON_MSGS__SRV__DETAIL__CAD_MATCH_DETECT_OBJECT__STRUCT_H_
