// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from rc_reason_msgs:srv/ComputeGrasps.idl
// generated code does not contain a copyright notice

#ifndef RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__TRAITS_HPP_
#define RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "rc_reason_msgs/srv/detail/compute_grasps__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'load_carrier_compartment'
#include "rc_reason_msgs/msg/detail/compartment__traits.hpp"
// Member 'item_models'
#include "rc_reason_msgs/msg/detail/item_model__traits.hpp"
// Member 'robot_pose'
#include "geometry_msgs/msg/detail/pose__traits.hpp"
// Member 'collision_detection'
#include "rc_reason_msgs/msg/detail/collision_detection__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ComputeGrasps_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: pose_frame
  {
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << ", ";
  }

  // member: region_of_interest_id
  {
    out << "region_of_interest_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_id, out);
    out << ", ";
  }

  // member: load_carrier_id
  {
    out << "load_carrier_id: ";
    rosidl_generator_traits::value_to_yaml(msg.load_carrier_id, out);
    out << ", ";
  }

  // member: load_carrier_compartment
  {
    out << "load_carrier_compartment: ";
    to_flow_style_yaml(msg.load_carrier_compartment, out);
    out << ", ";
  }

  // member: item_models
  {
    if (msg.item_models.size() == 0) {
      out << "item_models: []";
    } else {
      out << "item_models: [";
      size_t pending_items = msg.item_models.size();
      for (auto item : msg.item_models) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: suction_surface_length
  {
    out << "suction_surface_length: ";
    rosidl_generator_traits::value_to_yaml(msg.suction_surface_length, out);
    out << ", ";
  }

  // member: suction_surface_width
  {
    out << "suction_surface_width: ";
    rosidl_generator_traits::value_to_yaml(msg.suction_surface_width, out);
    out << ", ";
  }

  // member: robot_pose
  {
    out << "robot_pose: ";
    to_flow_style_yaml(msg.robot_pose, out);
    out << ", ";
  }

  // member: collision_detection
  {
    out << "collision_detection: ";
    to_flow_style_yaml(msg.collision_detection, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ComputeGrasps_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: pose_frame
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "pose_frame: ";
    rosidl_generator_traits::value_to_yaml(msg.pose_frame, out);
    out << "\n";
  }

  // member: region_of_interest_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "region_of_interest_id: ";
    rosidl_generator_traits::value_to_yaml(msg.region_of_interest_id, out);
    out << "\n";
  }

  // member: load_carrier_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_id: ";
    rosidl_generator_traits::value_to_yaml(msg.load_carrier_id, out);
    out << "\n";
  }

  // member: load_carrier_compartment
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "load_carrier_compartment:\n";
    to_block_style_yaml(msg.load_carrier_compartment, out, indentation + 2);
  }

  // member: item_models
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.item_models.size() == 0) {
      out << "item_models: []\n";
    } else {
      out << "item_models:\n";
      for (auto item : msg.item_models) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: suction_surface_length
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "suction_surface_length: ";
    rosidl_generator_traits::value_to_yaml(msg.suction_surface_length, out);
    out << "\n";
  }

  // member: suction_surface_width
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "suction_surface_width: ";
    rosidl_generator_traits::value_to_yaml(msg.suction_surface_width, out);
    out << "\n";
  }

  // member: robot_pose
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "robot_pose:\n";
    to_block_style_yaml(msg.robot_pose, out, indentation + 2);
  }

  // member: collision_detection
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "collision_detection:\n";
    to_block_style_yaml(msg.collision_detection, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ComputeGrasps_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::ComputeGrasps_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::ComputeGrasps_Request & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::ComputeGrasps_Request>()
{
  return "rc_reason_msgs::srv::ComputeGrasps_Request";
}

template<>
inline const char * name<rc_reason_msgs::srv::ComputeGrasps_Request>()
{
  return "rc_reason_msgs/srv/ComputeGrasps_Request";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::ComputeGrasps_Request>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::ComputeGrasps_Request>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::ComputeGrasps_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'timestamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"
// Member 'items'
#include "rc_reason_msgs/msg/detail/item__traits.hpp"
// Member 'load_carriers'
#include "rc_reason_msgs/msg/detail/load_carrier__traits.hpp"
// Member 'grasps'
#include "rc_reason_msgs/msg/detail/suction_grasp__traits.hpp"
// Member 'return_code'
#include "rc_common_msgs/msg/detail/return_code__traits.hpp"

namespace rc_reason_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const ComputeGrasps_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: timestamp
  {
    out << "timestamp: ";
    to_flow_style_yaml(msg.timestamp, out);
    out << ", ";
  }

  // member: items
  {
    if (msg.items.size() == 0) {
      out << "items: []";
    } else {
      out << "items: [";
      size_t pending_items = msg.items.size();
      for (auto item : msg.items) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: load_carriers
  {
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []";
    } else {
      out << "load_carriers: [";
      size_t pending_items = msg.load_carriers.size();
      for (auto item : msg.load_carriers) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: grasps
  {
    if (msg.grasps.size() == 0) {
      out << "grasps: []";
    } else {
      out << "grasps: [";
      size_t pending_items = msg.grasps.size();
      for (auto item : msg.grasps) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: return_code
  {
    out << "return_code: ";
    to_flow_style_yaml(msg.return_code, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ComputeGrasps_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: timestamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "timestamp:\n";
    to_block_style_yaml(msg.timestamp, out, indentation + 2);
  }

  // member: items
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.items.size() == 0) {
      out << "items: []\n";
    } else {
      out << "items:\n";
      for (auto item : msg.items) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: load_carriers
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.load_carriers.size() == 0) {
      out << "load_carriers: []\n";
    } else {
      out << "load_carriers:\n";
      for (auto item : msg.load_carriers) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: grasps
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.grasps.size() == 0) {
      out << "grasps: []\n";
    } else {
      out << "grasps:\n";
      for (auto item : msg.grasps) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: return_code
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "return_code:\n";
    to_block_style_yaml(msg.return_code, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ComputeGrasps_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace rc_reason_msgs

namespace rosidl_generator_traits
{

[[deprecated("use rc_reason_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const rc_reason_msgs::srv::ComputeGrasps_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  rc_reason_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use rc_reason_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const rc_reason_msgs::srv::ComputeGrasps_Response & msg)
{
  return rc_reason_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<rc_reason_msgs::srv::ComputeGrasps_Response>()
{
  return "rc_reason_msgs::srv::ComputeGrasps_Response";
}

template<>
inline const char * name<rc_reason_msgs::srv::ComputeGrasps_Response>()
{
  return "rc_reason_msgs/srv/ComputeGrasps_Response";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::ComputeGrasps_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<rc_reason_msgs::srv::ComputeGrasps_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<rc_reason_msgs::srv::ComputeGrasps_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<rc_reason_msgs::srv::ComputeGrasps>()
{
  return "rc_reason_msgs::srv::ComputeGrasps";
}

template<>
inline const char * name<rc_reason_msgs::srv::ComputeGrasps>()
{
  return "rc_reason_msgs/srv/ComputeGrasps";
}

template<>
struct has_fixed_size<rc_reason_msgs::srv::ComputeGrasps>
  : std::integral_constant<
    bool,
    has_fixed_size<rc_reason_msgs::srv::ComputeGrasps_Request>::value &&
    has_fixed_size<rc_reason_msgs::srv::ComputeGrasps_Response>::value
  >
{
};

template<>
struct has_bounded_size<rc_reason_msgs::srv::ComputeGrasps>
  : std::integral_constant<
    bool,
    has_bounded_size<rc_reason_msgs::srv::ComputeGrasps_Request>::value &&
    has_bounded_size<rc_reason_msgs::srv::ComputeGrasps_Response>::value
  >
{
};

template<>
struct is_service<rc_reason_msgs::srv::ComputeGrasps>
  : std::true_type
{
};

template<>
struct is_service_request<rc_reason_msgs::srv::ComputeGrasps_Request>
  : std::true_type
{
};

template<>
struct is_service_response<rc_reason_msgs::srv::ComputeGrasps_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // RC_REASON_MSGS__SRV__DETAIL__COMPUTE_GRASPS__TRAITS_HPP_
